/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return T}function t(){return x}function n(){return k}function l(e){k=e}function a(){return x.length-k}function o(){return x[k]}function r(){return x[k++]}function s(e){0===k?x.unshift(e):(k-=1,x[k]=e)}function i(){return(x[k++]<<8)+x[k++]}function u(){return(x[k++]<<24)+(x[k++]<<16)+(x[k++]<<8)+x[k++]}function d(e){"undefined"==typeof e&&(e=a());var t=x.slice(k,k+e);return k+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function c(e){return"undefined"==typeof e&&(e=a()),k+=e,x.slice(k-e,k)}function p(e,t){return t?x.slice(k+e,k+t):x.slice(k+e)}function h(e,t,n){var l=x.length-k;if(t>l){if(n){if(n>k)throw"rQwait cannot backup "+n+" bytes";k-=n}return!0}return!1}function m(){return Base64.encode(T)}function f(e){x=x.concat(Base64.decode(e,0))}function g(){return 0!==P.bufferedAmount&&Util.Debug("bufferedAmount: "+P.bufferedAmount),P.bufferedAmount<E.maxBufferedAmount?(T.length>0&&(P.send(m(T)),T=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+P.bufferedAmount),!1)}function v(e){return T=T.concat(e),g()}function b(e){E.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),a()>0?(I.message(),x.length>F&&(x=x.slice(k),k=0)):Util.Debug("Ignoring empty message")}catch(t){Util.Warn("undefined"!=typeof t.stack?"recv_message, caught exception: "+t.stack:"undefined"!=typeof t.description?"recv_message, caught exception: "+t.description:"recv_message, caught exception:"+t),I.error("undefined"!=typeof t.name?t.name+": "+t.message:t)}}function w(e,t){I[e]=t}function A(){x=[],k=0,T=[],P=null}function C(e){A(),P=N?{}:new WebSocket(e,"base64"),P.onmessage=y,P.onopen=function(){Util.Debug(">> WebSock.onopen"),P.protocol&&Util.Info("Server chose sub-protocol: "+P.protocol),I.open(),Util.Debug("<< WebSock.onopen")},P.onclose=function(e){Util.Debug(">> WebSock.onclose"),I.close(e),Util.Debug("<< WebSock.onclose")},P.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),I.error(e),Util.Debug("<< WebSock.onerror")}}function S(){P&&((P.readyState===WebSocket.OPEN||P.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),P.close()),P.onmessage=function(){})}function _(e){return N=!0,E.send=e,E.close=function(){},y}function D(){return E.maxBufferedAmount=200,E.get_sQ=e,E.get_rQ=t,E.get_rQi=n,E.set_rQi=l,E.rQlen=a,E.rQpeek8=o,E.rQshift8=r,E.rQunshift8=s,E.rQshift16=i,E.rQshift32=u,E.rQshiftStr=d,E.rQshiftBytes=c,E.rQslice=p,E.rQwait=h,E.flush=g,E.send=v,E.send_string=b,E.on=w,E.init=A,E.open=C,E.close=S,E.testMode=_,E}var E={},P=null,x=[],k=0,F=1e4,T=[],I={message:function(){},open:function(){},close:function(){},error:function(){}},N=!1;return D()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",l="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),l+=t+"web-socket-js/swfobject.js"+n,l+=t+"web-socket-js/web_socket.js"+n,document.write(l)}());